<div class="page">
  <p-table class="requests" #dt [value]="requests"
           [columns]="cols"
           selectionMode="single"
           [(selection)]="selectedRequest"
           [rowHover]="true"
           dataKey="id"
           [rows]="10"
           [showCurrentPageReport]="true"
           [paginator]="true"
           currentPageReportTemplate="Showing {first} to {last} out of {totalRecords} entries"
           [rowsPerPageOptions]="[10,25,50]"
           [filterDelay]="0"
           [scrollable]="true" scrollHeight="400px"
           styleClass="p-datatable-customers">

    <ng-template pTemplate="caption">
      <div class="table-title">
        List of Requests
        <span class="main-search">
                        <i class="pi pi-search"></i>
                        <input pInputText type="text" (input)="dt.filterGlobal($event.target.value, 'contains')"
                               placeholder="Search..."/>
          </span>
      </div>
      <div class="space">
      </div>
    </ng-template>

    <ng-template pTemplate="header" let-columns>
      <tr>
        <th *ngFor="let col of columns">
          {{col.header}}
        </th>
        <th></th>
      </tr>
      <tr>
        <th>
          <input pInputText type="text" (input)="dt.filter($event.target.value, 'assignmentId', 'contains')"
                 placeholder="Search by request id" class="p-column-filter">
        </th>

        <th>
          <input pInputText type="text" (input)="dt.filter($event.target.value, 'employeeName', 'contains')"
                 placeholder="Search by employee name" class="p-column-filter">
        </th>

        <th>
          <input pInputText type="text" (input)="dt.filter($event.target.value, 'status', 'contains')"
                 placeholder="Search by status" class="p-column-filter">
        </th>

        <th>
          <input pInputText type="text" (input)="dt.filter($event.target.value, 'importance', 'contains')"
                 placeholder="Search by importance" class="p-column-filter">
        </th>

        <th>
        </th>
      </tr>

    </ng-template>

    <ng-template pTemplate="body" let-request>
      <tr [pSelectableRow]="request">
        <td>{{request.assignmentId}}</td>
        <td>{{request.employeeName}}</td>
        <td>{{request.status}}</td>
        <td>{{request.importance}}</td>
        <td>
          <button pButton pRipple icon="pi pi-pencil" class="p-button-rounded p-button-success p-mr-2"
                  (click)="editRequest(request)">See details
          </button>
        </td>
      </tr>
    </ng-template>

    <ng-template pTemplate="paginator-right">

    </ng-template>

  </p-table>

</div>

<p-dialog [(visible)]="requestDialog" header="Request Details" class="request-details" [modal]="true">
  <ng-template pTemplate="content">
    <div class="p-field">
      <label for="assignmentId">Assignment Id</label>
      <input type="text" pInputText id="assignmentId" [(ngModel)]="request.assignmentId" required autofocus/>
      <small class="p-invalid" *ngIf="submitted && !request.assignmentId">Assignment id is required.</small>
    </div>

    <div>
      <label for="employeeName">employeeName</label>
      <input type="text" pInputText id="employeeName" [(ngModel)]="request.employeeName" required autofocus/>
      <small class="p-invalid" *ngIf="submitted && !request.employeeName">Employee Name is required.</small>
    </div>

    <div>
      <label for="status">status</label>
      <input type="text" pInputText id="status" [(ngModel)]="request.status" required autofocus/>
      <small class="p-invalid" *ngIf="submitted && !request.status">Status is required.</small>
    </div>

    <div>
      <label for="importance">importance</label>
      <input type="text" pInputText id="importance" [(ngModel)]="request.importance" required autofocus/>
      <small class="p-invalid" *ngIf="submitted && !request.importance">Importance is required.</small>
    </div>

  </ng-template>
</p-dialog>


